/* ----------------------------------------------
	Nyisztor Kroly
	Shader programozs
	Grafika s jtkfejleszts DirectX-szel II
	
	FX fjl	: CubeMap.fx
	
	Lsd	: 11.9.3. Krnyezeti trkp
			  404. oldal
------------------------------------------------- */
uniform extern float4x4 gWorldViewProjection;
uniform extern texture  gCubeMap;

sampler CubeMapSampler = sampler_state
{
    Texture   = <gCubeMap>;
    MinFilter = LINEAR; 
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU  = WRAP;
    AddressV  = WRAP;
};

struct VS_OUTPUT 
{
	float4 PositionProj : POSITION0;
    float3 Tex0 : TEXCOORD0;
};

VS_OUTPUT vs_main(float3 posLocal_in : POSITION0 )
{
	VS_OUTPUT outVS;
	// z = w, gy  z/w = 1 (mindig a tvoli vgskon).
    outVS.PositionProj = mul(float4(posLocal_in, 1.0f), gWorldViewProjection).xyww;
	
    // a vertex loklis helyzete - index a 3D-textrba. 
    outVS.Tex0 = posLocal_in;
	return outVS;
}

float4 ps_main(float3 tex0_in : TEXCOORD0) : COLOR
{
    return texCUBE(CubeMapSampler, tex0_in);
}

technique CubeMapTech
{
    pass P0
    {
		CullMode = None;
		ZFunc = Always; 

		vertexShader = compile vs_2_0 vs_main();
        pixelShader  = compile ps_2_0 ps_main();
    }
}

