#if !defined( CTIMER_H )
#define CTIMER_H
/* Shaderprogramozás - Grafika és játékfejlesztés DirectX-szel ----------------

	Állomány          : CTimer.h

    Nyelv             : C++

    Létrehozás dátuma : 2008.08.28

    Utolsó módosítás  : 2009.03.15

    Leírás            : Shaderprogramozás
						Grafika és játékfejlesztés DirectX-szel
						11.1.8. "Időzítés"
						291. oldal
	Központi időzítő osztály
               Copyright (C) Nyisztor Károly 2008-2009
							www.directx.hu
-----------------------------------------------------------------------------*/
#pragma comment(lib,"winmm.lib") // timeGetTime()
/*- Befordított fejállományok -----------------------------------------------*/
#include <windows.h>
#include <stdio.h>
#include <mmsystem.h>
#include <ctime>

#include <string>
using std::string;
/*- Névterek ----------------------------------------------------------------*/
namespace app
{
/*!
 * \brief időzítő osztályok névtere
 * 
 * \author Nyisztor Károly
 * \date 2007 - 2008
 */
namespace timer
{
/*!
 * \brief Idő mérését és időzítést szolgáló osztály
 * \remarks 
 * Időzítés, FPS, képkockák kirajzolása közt eltelt idő és egyéb 
 * statisztikai adatok
 */
class CTimer{
private:
	DWORD myFramesPerSec;
	DWORD myTotalFrameCnt;
	
	DWORD myCurrentFPS;
	DWORD myMinFPS;
	DWORD myMaxFPS;
	
	double myMinFrameTime;
	double myMaxFrameTime;
	double myCurrentFrameTime;
	
	_int64 myStartTime;
	
	_int64 myUpdateStartTime;

	_int64 myFreq;	
	double myTimeScale;

	bool myPerfCounterAvailable;
	
	double myLastElapsedTime;
	double myElapsedTime;
	_int64 myCurrentTime;
	_int64 myLastTimeHere;

	char myFPSStrBuffer[1024];

public:
	CTimer();

	void logTimer();

	const DWORD getFPS() const;
	const char* getFPSString();

	const double getAvgFPS();
	const char* getAvgFPSString();

	const double getFrameTime() const;
	const char* getFrameTimeString();

	void update();   
	void resetTimer();
	double getTimeElapsed();

	_int64 getTime();
private:
	
	void init();
};

}; // namespace timer
}; // namespace game

#endif //#ifndef CTIMER_H
